//
// Created by jtwite on 30.03.20.
//

#ifndef PROJET_Q4_GROUPE_O4_FILEFEATURES_H
#define PROJET_Q4_GROUPE_O4_FILEFEATURES_H


#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include <math.h>


//functions:
int factorize(char *file_in_memory, FILE *fileOutput);
int factAndWrite(FILE *out, int n);
int ipow(int base, int exp);

// iterate through a mapped file and write each number found and factorize them
// the program stop if file_in_memory contains anything else than a digit or a '\n'
int factorize(char *file_in_memory, FILE *fileOutput) {
    int line = 1;
    int start = 0;
    int size = strlen(file_in_memory);
    int i = 0;
    while (i < size) {
        if (file_in_memory[i] == '\n' && i > start) {   // if we are at the end of the line
            int k = 0;
            for (int j = i - 1; j >= start; j--)        // iterate from right to left
                k += ((file_in_memory[j] - '0') *ipow(10, i - j - 1)); // record each digit into k
            
            if(k < 2)
                printf("Entier plus petit que 2 (line %d): %d\n", line, k);
            else 
            factAndWrite(fileOutput, k);      // write and factorize k in fileOutput
            start = i += 1;
            line ++;
        }
        else if ((file_in_memory[i] > '9' || file_in_memory[i] < '0') && file_in_memory[i] != '\n') {
            printf("Entier mal formatté (line %d): %c.\n", line, file_in_memory[i]);
            while(file_in_memory[i]!= '\n')
                i++;
        line++;
        }
        else
            i++;
    }
    return 0;
}

// * write n and its factorization in the file @out *
int factAndWrite(FILE *out, int n) {
    int x = n;
    fprintf(out, "%d", n);
    while (n % 2 == 0) {
            fprintf(out, " 2");
            n /= 2;
    }
    for (int i = 3; x >= i*i; i+=2)
        while (n % i == 0) {
            fprintf(out, " %d", i);
            n /= i;
        }
    if(n > 1 && n < x)    
        fprintf(out, " %d", n);
    fprintf(out, " \n");
    return 0;
}


int ipow(int base, int exp) {
    int result = 1;
    for (;;) {
        if (exp & 1)
            result *= base;
        exp >>= 1;
        if (!exp)
            break;
        base *= base;
    }
    return result;
}

#endif //PROJET_Q4_GROUPE_O4_FILEFEATURES_H
